## glibc 2.42

=== Makefile ===
# Copyright (C) 1991-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Master Makefile for the GNU C library
#
ifneq (,)
This makefile requires GNU Make.
endif

include Makeconfig


# This is the default target; it makes everything except the tests.
.PHONY: all help minihelp
all: minihelp lib others

help:
	@sed '0,/^help-starts-here$$/d' Makefile.help

minihelp:
	@echo
	@echo type \"make help\" for help with common glibc makefile targets
	@echo


ifneq ($(AUTOCONF),no)

define autoconf-it
@-rm -f $@.new
$(AUTOCONF) $(ACFLAGS) $< > $@.new
chmod a-w$(patsubst %,$(comma)a+x,$(filter .,$(@D))) $@.new
mv -f $@.new $@
endef

configure: configure.ac aclocal.m4; $(autoconf-it)
%/configure: %/configure.ac aclocal.m4; $(autoconf-it)
%/preconfigure: %/preconfigure.ac aclocal.m4; $(autoconf-it)

endif # $(AUTOCONF) = no


# We don't want to run anything here in parallel.
.NOTPARALLEL:

# These are the targets that are made by making them in each subdirectory.
+subdir_targets	:= subdir_lib objects objs others subdir_mostlyclean	\
		   subdir_clean subdir_distclean subdir_realclean	\
		   tests xtests						\
		   subdir_update-abi subdir_check-abi			\
		   subdir_update-all-abi				\
		   subdir_echo-headers					\
		   subdir_install					\
		   subdir_objs subdir_stubs subdir_testclean		\
		   $(addprefix install-, no-libc.a bin lib data headers others)

headers := limits.h values.h features.h features-time64.h gnu-versions.h \
	   bits/xopen_lim.h gnu/libc-version.h stdc-predef.h \
	   bits/libc-header-start.h

echo-headers: subdir_echo-headers

# The headers are in the include directory.
subdir-dirs = include
vpath %.h $(subdir-dirs)

# What to install.
install-others = $(inst_includedir)/gnu/stubs.h
install-bin-script =

ifeq (yes,$(build-shared))
headers += gnu/lib-names.h
endif

include Makerules

ifeq ($(build-programs),yes)
others: $(addprefix $(objpfx),$(install-bin-script))
endif

# Install from subdirectories too.
install: subdir_install

# Explicit dependency so that `make install-headers' works
install-headers: install-headers-nosubdir

# Make sure that the dynamic linker is installed before libc.
$(inst_slibdir)/libc-$(version).so: elf/ldso_install

.PHONY: elf/ldso_install
elf/ldso_install:
	$(MAKE) -C $(@D) $(@F)

# Create links for shared libraries using the `ldconfig' program if possible.
# Ignore the error if we cannot update /etc/ld.so.cache.
ifeq (no,$(cross-compiling))
ifeq (yes,$(build-shared))
install:
	-test ! -x $(elf-objpfx)ldconfig || LC_ALL=C \
	  $(elf-objpfx)ldconfig $(addprefix -r ,$(install_root)) \
				$(slibdir) $(libdir)
ifneq (no,$(PERL))
ifeq (/usr,$(prefix))
ifeq (,$(install_root))
	LD_SO=$(ld.so-version) CC="$(CC)" $(PERL) scripts/test-installation.pl $(common-objpfx)
endif
endif
endif
endif
endif

# Build subdirectory lib objects.
lib-noranlib: subdir_lib

ifeq (yes,$(build-shared))
# Build the shared object from the PIC object library.
lib: $(common-objpfx)libc.so $(common-objpfx)linkobj/libc.so
endif # $(build-shared)

# Used to build testrun.sh.
define testrun-script
#!/bin/bash
builddir=`dirname "$$0"`
GCONV_PATH="$${builddir}/iconvdata"

usage () {
cat << EOF
Usage: $$0 [OPTIONS] <program> [ARGUMENTS...]

  --tool=TOOL  Run with the specified TOOL. It can be strace, rpctrace,
               valgrind or container. The container will run within
               support/test-container.  For strace and valgrind,
               additional arguments can be passed after the tool name.
EOF

  exit 1
}

toolname=default
while test $$# -gt 0 ; do
  case "$$1" in
    --tool=*)
      toolname="$${1:7}"
      shift
      ;;
    --*)
      usage
      ;;
    *)
      break
      ;;
  esac
done

if test $$# -eq 0 ; then
  usage
fi

case "$$toolname" in
  default)
    exec $(subst $(common-objdir),"$${builddir}", $(test-program-prefix)) \
      $${1+"$$@"}
    ;;
  strace*)
    exec $$toolname $(patsubst %, -E%, $(run-program-env)) \
      $(test-via-rtld-prefix) $${1+"$$@"}
    ;;
  rpctrace)
    exec rpctrace $(patsubst %, -E%, $(run-program-env)) \
      $(test-via-rtld-prefix) $${1+"$$@"}
    ;;
  valgrind*)
    exec env $(run-program-env) $$toolname $(test-via-rtld-prefix) $${1+"$$@"}
    ;;
  container)
    exec env $(run-program-env) $(test-via-rtld-prefix) \
      $(common-objdir)/support/test-container \
      env $(run-program-env) $(test-via-rtld-prefix) $${1+"$$@"}
    ;;
  *)
    usage
    ;;
esac
endef

# This is a handy script for running any dynamically linked program against
# the current libc build for testing.
$(common-objpfx)testrun.sh: $(common-objpfx)config.make \
			    $(..)Makeconfig $(..)Makefile
	$(file >$@T,$(testrun-script))
	chmod a+x $@T
	mv -f $@T $@
postclean-generated += testrun.sh

define debugglibc
#!/bin/bash

SOURCE_DIR="$(CURDIR)"
BUILD_DIR="$(common-objpfx)"
CMD_FILE="$(common-objpfx)debugglibc.gdb"
CONTAINER=false
DIRECT=true
STATIC=false
SYMBOLSFILE=true
unset TESTCASE
unset BREAKPOINTS
unset ENVVARS

usage()
{
cat << EOF
Usage: $$0 [OPTIONS] <program>

   Or: $$0 [OPTIONS] -- <program> [<args>]...

  where <program> is the path to the program being tested,
  and <args> are the arguments to be passed to it.

Options:

  -h, --help
	Prints this message and leaves.

  The following options require one argument:

  -b, --breakpoint
	Breakpoints to set at the beginning of the execution
	(each breakpoint demands its own -b option, e.g. -b foo -b bar)
  -e, --environment-variable
	Environment variables to be set with 'exec-wrapper env' in GDB
	(each environment variable demands its own -e option, e.g.
	-e FOO=foo -e BAR=bar)

  The following options do not take arguments:

  -c, --in-container
	Run the test case inside a container and automatically attach
	GDB to it.
  -i, --no-direct
	Selects whether to pass the --direct flag to the program.
	--direct is useful when debugging glibc test cases. It inhibits the
	tests from forking and executing in a subprocess.
	Default behaviour is to pass the --direct flag, except when the
	program is run with user specified arguments using the "--" separator.
  -s, --no-symbols-file
	Do not tell GDB to load debug symbols from the program.
EOF
}

# Parse input options
while [[ $$# > 0 ]]
do
  key="$$1"
  case $$key in
    -h|--help)
      usage
      exit 0
      ;;
    -b|--breakpoint)
      BREAKPOINTS="break $$2\n$$BREAKPOINTS"
      shift
      ;;
    -e|--environment-variable)
      ENVVARS="$$2 $$ENVVARS"
      shift
      ;;
    -c|--in-container)
      CONTAINER=true
      ;;
    -i|--no-direct)
      DIRECT=false
      ;;
    -s|--no-symbols-file)
      SYMBOLSFILE=false
      ;;
    --)
      shift
      TESTCASE=$$1
      COMMANDLINE="$$@"
      # Don't add --direct when user specifies program arguments
      DIRECT=false
      break
      ;;
    *)
      TESTCASE=$$1
      COMMANDLINE=$$TESTCASE
      ;;
  esac
  shift
done

# Check for required argument and if the testcase exists
if [ ! -v TESTCASE ] || [ ! -f $${TESTCASE} ]
then
  usage
  exit 1
fi

# Container tests needing locale data should install them in-container.
# Other tests/binaries need to use locale data from the build tree.
if [ "$$CONTAINER" = false ]
then
  ENVVARS="GCONV_PATH=$${BUILD_DIR}/iconvdata $$ENVVARS"
  ENVVARS="LOCPATH=$${BUILD_DIR}/localedata $$ENVVARS"
  ENVVARS="LC_ALL=C $$ENVVARS"
fi

# Expand environment setup command
if [ -v ENVVARS ]
then
  ENVVARSCMD="set exec-wrapper env $$ENVVARS"
fi

# Expand direct argument
if [ "$$DIRECT" == true ]
then
  DIRECT="--direct"
else
  DIRECT=""
fi

# Check if the test case is static
if file $${TESTCASE} | grep "statically linked" >/dev/null
then
  STATIC=true
else
  STATIC=false
fi

# Expand symbols loading command
if [ "$$SYMBOLSFILE" == true ]
then
  SYMBOLSFILE="add-symbol-file $${TESTCASE}"
else
  SYMBOLSFILE=""
fi

# GDB commands template
template ()
{
cat <<EOF
set environment C -E -x c-header
set auto-load safe-path $${BUILD_DIR}/nptl_db:\$$debugdir:\$$datadir/auto-load
set libthread-db-search-path $${BUILD_DIR}/nptl_db
__ENVVARS__
__SYMBOLSFILE__
break _dl_start_user
run --library-path $(rpath-link):$${BUILD_DIR}/nptl_db \
__COMMANDLINE__ __DIRECT__
__BREAKPOINTS__
EOF
}

# Generate the commands file for gdb initialization
template | sed \
  -e "s|__ENVVARS__|$$ENVVARSCMD|" \
  -e "s|__SYMBOLSFILE__|$$SYMBOLSFILE|" \
  -e "s|__COMMANDLINE__|$$COMMANDLINE|" \
  -e "s|__DIRECT__|$$DIRECT|" \
  -e "s|__BREAKPOINTS__|$$BREAKPOINTS|" \
  > $$CMD_FILE

echo
echo "Debugging glibc..."
echo "Build directory  : $$BUILD_DIR"
echo "Source directory : $$SOURCE_DIR"
echo "GLIBC Testcase   : $$TESTCASE"
echo "GDB Commands     : $$CMD_FILE"
echo "Env vars         : $$ENVVARS"
echo

if [ "$$CONTAINER" == true ]
then
# Use testrun.sh to start the test case with WAIT_FOR_DEBUGGER=1, then
# automatically attach GDB to it.
WAIT_FOR_DEBUGGER=1 $(common-objpfx)testrun.sh --tool=container $${TESTCASE} &
gdb -x $${TESTCASE}.gdb
elif [ "$$STATIC" == true ]
then
gdb $${TESTCASE}
else
# Start the test case debugging in two steps:
#   1. the following command invokes gdb to run the loader;
#   2. the commands file tells the loader to run the test case.
gdb -q \
  -x $${CMD_FILE} \
  -d $${SOURCE_DIR} \
  $${BUILD_DIR}/elf/ld.so
fi
endef

# This is another handy script for debugging dynamically linked program
# against the current libc build for testing.
$(common-objpfx)debugglibc.sh: $(common-objpfx)config.make \
			    $(..)Makeconfig $(..)Makefile
	$(file >$@T,$(debugglibc))
	chmod a+x $@T
	mv -f $@T $@
postclean-generated += debugglibc.sh debugglibc.gdb

others: $(common-objpfx)testrun.sh $(common-objpfx)debugglibc.sh

# Makerules creates a file `stubs' in each subdirectory, which
# contains `#define __stub_FUNCTION' for each function defined in that
# directory which is a stub.
# Here we paste all of these together into <gnu/stubs.h>.

subdir-stubs := $(foreach dir,$(subdirs),$(common-objpfx)$(dir)/stubs)

ifndef abi-variants
installed-stubs = $(inst_includedir)/gnu/stubs.h
else
installed-stubs = $(inst_includedir)/gnu/stubs-$(default-abi).h

$(inst_includedir)/gnu/stubs.h: $(+force)
	$(make-target-directory)
	{ \
	 echo '/* This file is automatically generated.';\
	 echo "   This file selects the right generated file of \`__stub_FUNCTION' macros";\
	 echo '   based on the architecture being compiled for.  */'; \
	 echo ''; \
	 $(foreach h,$(abi-includes), echo '#include <$(h)>';) \
	 echo ''; \
	 $(foreach v,$(abi-variants),\
	 $(if $(abi-$(v)-condition),\
	 echo '#if $(abi-$(v)-condition)'; \
	 echo '# include <gnu/stubs-$(v).h>'); \
	 $(if $(abi-$(v)-condition),echo '#endif';) \
	 rm -f $(@:.d=.h).new$(v); \
	 ) \
	} > $(@:.d=.h).new
	mv -f $(@:.d=.h).new $(@:.d=.h)

install-others-nosubdir: $(installed-stubs)
endif


# Since stubs.h is never needed when building the library, we simplify the
# hairy installation process by producing it in place only as the last part
# of the top-level `make install'.  It depends on subdir_install, which
# iterates over all the subdirs; subdir_install in each subdir depends on
# the subdir's stubs file.  Having more direct dependencies would result in
# extra iterations over the list for subdirs and many recursive makes.
$(installed-stubs): include/stubs-prologue.h subdir_install
	$(make-target-directory)
	@rm -f $(objpfx)stubs.h

=== assert/Makefile ===
# Copyright (C) 1991-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for assert portion of the library.
#
subdir	:= assert

include ../Makeconfig

headers := \
  assert.h
  # headers

routines := \
  __assert \
  __libc_assert_fail \
  assert \
  assert-perr \
  # routines

tests := \
  test-assert \
  test-assert-2 \
  test-assert-perr \
  tst-assert-c++ \
  tst-assert-g++ \
  tst-assert-sa-2025-0001 \
  # tests

ifeq ($(have-cxx-thread_local),yes)
CFLAGS-tst-assert-c++.o = -std=c++11
LDLIBS-tst-assert-c++ = -lstdc++
CFLAGS-tst-assert-g++.o = -std=gnu++11
LDLIBS-tst-assert-g++ = -lstdc++
else
tests-unsupported += \
  tst-assert-c++ \
  tst-assert-g++ \
  # tests-unsupported
endif

include ../Rules

=== csu/Makefile ===
# Makefile for csu code for GNU C library.
# Copyright (C) 1995-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

# This directory contains the C startup code (that which calls main).  This
# consists of the startfile, built from start.c and installed as crt0.o
# (traditionally) or crt1.o (for ELF).	In ELF we also install crti.o and
# crtn.o, special "initializer" and "finalizer" files used in the link
# to make the .init and .fini sections work right.

subdir := csu

include ../Makeconfig

routines = \
  $(libc-init) \
  check_fds \
  dso_handle \
  init-first \
  libc-start \
  libc-tls \
  sysdep \
  version \
  # routines
aux	 = errno
elide-routines.os = libc-tls
csu-dummies = $(filter-out $(start-installed-name),crt1.o Mcrt1.o)
extra-objs = \
  $(csu-dummies) \
  $(start-installed-name) \
  $(start-name-2.0) \
  S$(start-installed-name) \
  g$(start-installed-name) \
  start.o \
  # extra-objs
omit-deps = $(patsubst %.o,%,$(start-installed-name) g$(start-installed-name) \
			     b$(start-installed-name) $(csu-dummies) \
			     S$(start-installed-name) \
			     r$(start-installed-name) \
			     gr$(start-installed-name))
install-lib = \
  $(csu-dummies) \
  $(start-installed-name) \
  g$(start-installed-name) \
  # install-lib

# No tests are allowed in the csu/ subdirectory because the startup
# code is compiled with special flags.
tests =

# static-reloc.os is a dummy object not actually used for anything.  It is
# linked into crt1.o nevertheless, which in turn is statically linked into
# applications, so that build flags matter.
# See <https://sourceware.org/ml/libc-alpha/2018-07/msg00101.html>.
#
# The function is called prior the thread pointer setup, and if stack
# protector is enabled the compiler might still generate the stack check
# (which requires the thread pointer correctly set).
extra-no-ssp = static-reloc

# libc-start.os is safe to be built with stack protector since
# __libc_start_main is called after stack canary setup is done.
ssp-safe.os = libc-start

CFLAGS-.o += $(call elide-stack-protector,.o,$(routines) $(extra-no-ssp))
CFLAGS-.op += $(call elide-stack-protector,.op,$(routines) $(extra-no-ssp))
CFLAGS-.oS += $(call elide-stack-protector,.oS,$(routines) $(extra-no-ssp))
CFLAGS-.os += $(call elide-stack-protector,.os,$(filter-out \
						 $(ssp-safe.os), \
						 $(routines) $(extra-no-ssp)))

ifeq (yes,$(build-shared))
extra-objs += \
  S$(start-installed-name) \
  gmon-start.os \
  # extra-objs
ifneq ($(start-installed-name),$(static-start-installed-name))
extra-objs += gmon-start.o
endif
install-lib += S$(start-installed-name)
generated += start.os
else
extra-objs += gmon-start.o
endif

ifeq (yes,$(enable-static-pie))
extra-objs += \
  gr$(start-installed-name) \
  r$(start-installed-name) \
  # extra-objs
install-lib += \
  gr$(start-installed-name) \
  r$(start-installed-name) \
  # install-lib
endif

ifneq ($(start-installed-name),$(static-start-installed-name))
extra-objs += \
  $(static-start-installed-name) \
  g$(static-start-installed-name) \
  # extra-objs
omit-deps += $(patsubst %.o,%,$(static-start-installed-name) \
			     g$(static-start-installed-name))
install-lib += \
  $(static-start-installed-name) \
  g$(static-start-installed-name) \
  # install-lib
ifeq (yes,$(enable-static-pie))
extra-objs += \
  gr$(static-start-installed-name) \
  r$(static-start-installed-name) \
  # extra-objs
omit-deps += $(patsubst %.o,%,r$(static-start-installed-name) \
			     gr$(static-start-installed-name))
install-lib += \
  gr$(static-start-installed-name) \
  r$(static-start-installed-name) \
  # install-lib
endif
endif

before-compile += $(objpfx)abi-tag.h
generated += abi-tag.h

# Put it here to generate it earlier.
gen-as-const-headers += rtld-sizes.sym

# These are the special initializer/finalizer files.  They are always the
# first and last file in the link.  crti.o ... crtn.o define the global
# "functions" _init and _fini to run the .init and .fini sections.
crtstuff = \
  crti \
  crtn \
  # crtstuff

install-lib += $(crtstuff:=.o)
extra-objs += $(crtstuff:=.o)

ifneq ($(multidir),.)
multilib-extra-objs = $(addprefix $(multidir)/, $(install-lib))
extra-objs += $(multilib-extra-objs)
endif

extra-objs += \
  abi-note.o \
  init.o \
  static-reloc.o \
  # extra-objs
ifeq (yes,$(build-shared))
extra-objs += static-reloc.os
endif
asm-CPPFLAGS += -I$(objpfx).

# Enable unwinding so backtrace unwinds to __libc_start_main
CFLAGS-libc-start.c += -funwind-tables

include ../Rules

# Make these in the lib pass so they're available in time to link things with.
subdir_lib: $(extra-objs:%=$(objpfx)%)

define link-relocatable
$(CC) -nostdlib -nostartfiles -r -o $@ $^
endef

ifndef start-installed-name-rule
# We link the ELF startfile along with a SHT_NOTE section indicating
# the kernel ABI the binaries linked with this library will require.
$(objpfx)$(start-installed-name): $(objpfx)start.o $(objpfx)abi-note.o \
				  $(objpfx)init.o $(objpfx)static-reloc.o
	$(link-relocatable)
$(objpfx)$(start-name-2.0): $(objpfx)start.o $(objpfx)abi-note.o \
			    $(objpfx)static-reloc.o
	$(link-relocatable)
$(objpfx)r$(start-installed-name): $(objpfx)start.o $(objpfx)abi-note.o \
				  $(objpfx)init.o
	$(link-relocatable)
$(objpfx)S$(start-installed-name): $(objpfx)start.os $(objpfx)abi-note.o \
				  $(objpfx)init.o
	$(link-relocatable)
endif

# The profiling startfile is made by linking together the normal
# startfile with gmon-start.o, which defines a constructor function
# to turn on profiling code at startup.
ifeq (yes,$(build-shared))
$(objpfx)g$(start-installed-name): \
  $(objpfx)g%: $(objpfx)S% $(objpfx)gmon-start.os $(objpfx)static-reloc.os
	$(link-relocatable)
$(objpfx)gr$(start-installed-name): \
  $(objpfx)gr%: $(objpfx)r% $(objpfx)gmon-start.o
	$(link-relocatable)
ifneq ($(start-installed-name),$(static-start-installed-name))
$(objpfx)g$(static-start-installed-name): \
  $(objpfx)g%: $(objpfx)% $(objpfx)gmon-start.o
	$(link-relocatable)
$(objpfx)gr$(static-start-installed-name): \
  $(objpfx)gr%: $(objpfx)r% $(objpfx)gmon-start.o
	$(link-relocatable)
endif
else
$(addprefix $(objpfx),$(sort g$(start-installed-name) \
			     g$(static-start-installed-name))): \
  $(objpfx)g%: $(objpfx)% $(objpfx)gmon-start.o
	$(link-relocatable)
endif

# These extra files are sometimes expected by system standard linking
# procedures, but we have nothing for them to do.  So compile empty files.
$(addprefix $(objpfx),$(filter-out $(start-installed-name), $(csu-dummies))):\
  $(before-compile)
	$(COMPILE.c) -o $@ -x c /dev/null

# These headers are used by the startup code.
$(objpfx)abi-tag.h: $(..)abi-tags
	$(make-target-directory)
	rm -f $@.new
	sed -e 's/#.*$$//' -e '/^[	]*$$/d' $< | \
	while read conf tagos tagver; do \
	  test `expr '$(config-machine)-$(config-vendor)-$(config-os)' \
		     : "$$conf"` != 0 || continue; \
	  ( echo "$$tagos" | \
	    sed -e 's/[^0-9xXa-fA-F 	]//' \
		-e 's/^/#define __ABI_TAG_OS /'; \
	    echo "#ifndef __ABI_TAG_VERSION"; \
	    echo "$$tagver" | \
	    sed -e 's/[^0-9xXa-fA-F]/ /g' -e 's/ *$$//' \
	      -e 's/ /,/g' -e 's/^/# define __ABI_TAG_VERSION /'; \
	    echo "#endif" ) > $@.new; \
	done
	if test -r $@.new; then mv -f $@.new $@; \
	else echo >&2 'This configuration not matched in $<'; exit 1; fi

ifneq ($(multidir),.)
$(addprefix $(objpfx)$(multidir)/, $(install-lib)): $(addprefix $(objpfx), $(install-lib))
	$(make-link-multidir)
endif

=== ctype/Makefile ===
# Copyright (C) 1991-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for ctype portion of the library.
#
subdir	:= ctype

include ../Makeconfig

headers	:= ctype.h

routines := \
  ctype \
  ctype-c99 \
  ctype-c99_l \
  ctype-extn \
  ctype_l \
  isctype \
  # routines
aux := ctype-info

tests := \
  test_ctype \
  tst-ctype-tls-dlmopen \
  tst-ctype-tls-dlopen-static \
  # tests

tests-static := \
  tst-ctype-tls-dlopen-static \
  # tests-static

modules-names := \
  tst-ctype-tls-mod \
  # modules-names

include ../Rules

$(objpfx)tst-ctype-tls-dlmopen: $(shared-thread-library)
$(objpfx)tst-ctype-tls-dlmopen.out: $(objpfx)tst-ctype-tls-mod.so
$(objpfx)tst-ctype-tls-dlopen-static: $(static-thread-library)
$(objpfx)tst-ctype-tls-dlopen-static.out: $(objpfx)tst-ctype-tls-mod.so
tst-ctype-tls-dlopen-static-ENV = \
  LD_LIBRARY_PATH=$(ld-library-path):$(common-objpfx):$(common-objpfx)elf

=== dirent/Makefile ===
# Copyright (C) 1991-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for dirent portion of the library.
#
subdir		:= dirent

include ../Makeconfig

headers := \
  bits/dirent.h \
  bits/dirent_ext.h \
  dirent.h \
  # headers
routines := \
  alphasort \
  alphasort64 \
  closedir \
  dirfd \
  fdopendir \
  getdents \
  getdents64 \
  opendir \
  readdir \
  readdir64 \
  readdir64_r \
  readdir_r \
  rewinddir \
  scandir \
  scandir-cancel \
  scandir-tail \
  scandir64 \
  scandir64-tail \
  scandirat \
  scandirat64 \
  seekdir \
  telldir \
  versionsort \
  versionsort64 \
  # routines

tests := \
  bug-readdir1 \
  list \
  opendir-tst1 \
  tst-closedir-leaks \
  tst-fdopendir \
  tst-fdopendir2 \
  tst-readdir-long \
  tst-readdir-zero-inode \
  tst-rewinddir \
  tst-scandir \
  tst-scandir64 \
  tst-seekdir \
  # tests

ifeq ($(run-built-tests),yes)
ifneq ($(PERL),no)
generated += \
  $(objpfx)tst-closedir-leaks-mem.out \
  # generated

tests-special += \
  $(objpfx)tst-closedir-leaks-mem.out \
  # tests-special
endif # $(PERL) ! no
endif # $(run-built-tests) == yes

CFLAGS-scandir.c += $(uses-callbacks)
CFLAGS-scandir64.c += $(uses-callbacks)
CFLAGS-scandir-tail.c += $(uses-callbacks)
CFLAGS-scandir64-tail.c += $(uses-callbacks)
CFLAGS-dirfd.c += $(config-cflags-wno-ignored-attributes)

include ../Rules

opendir-tst1-ARGS = --test-dir=${common-objpfx}dirent

tst-closedir-leaks-ENV += MALLOC_TRACE=$(objpfx)tst-closedir-leaks.mtrace \
		   LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so

$(objpfx)tst-closedir-leaks-mem.out: $(objpfx)tst-closedir-leaks.out
	$(common-objpfx)malloc/mtrace $(objpfx)tst-closedir-leaks.mtrace > $@; \
	$(evaluate-test)

=== elf/Makefile ===
# Copyright (C) 1995-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

# Makefile for elf subdirectory of GNU C Library.

subdir		:= elf

include ../Makeconfig

headers = \
  bits/elfclass.h \
  bits/link.h \
  bits/link_lavcurrent.h \
  elf.h \
  link.h \
  # headers

routines = \
  $(all-dl-routines) \
  dl-addr \
  dl-addr-obj \
  dl-early_allocate \
  dl-iteratephdr \
  dl-libc \
  dl-origin \
  dl-reloc-static-pie \
  dl-support \
  dl-sym \
  dl-sysdep \
  enbl-secure \
  libc-dl-profstub  \
  libc-dl_find_object \
  libc_early_init \
  rtld_static_init \
  # routines

# The core dynamic linking functions are in libc for the static and
# profiled libraries.
dl-routines = \
  dl-call-libc-early-init \
  dl-call_fini \
  dl-catch \
  dl-close \
  dl-debug \
  dl-debug-symbols \
  dl-debug_state \
  dl-deps \
  dl-exception \
  dl-execstack \
  dl-execstack-tunable \
  dl-find_object \
  dl-fini \
  dl-init \
  dl-load \
  dl-lookup \
  dl-lookup-direct \
  dl-minimal-malloc \
  dl-misc \
  dl-object \
  dl-open \
  dl-origin \
  dl-printf \
  dl-readonly-area \
  dl-reloc \
  dl-runtime \
  dl-scope \
  dl-setup_hash \
  dl-sort-maps \
  dl-thread_gscope_wait \
  dl-tls \
  dl-tls_init_tp \
  dl-trampoline \
  dl-tunables \
  dl-version \
  dl-write \
  # dl-routines

ifeq (yes,$(use-ldconfig))
dl-routines += dl-cache
endif

ifeq (yesyes,$(build-shared)$(run-built-tests))
tests-special += $(objpfx)list-tunables.out
endif

# Make sure that the compiler does not insert any library calls in tunables
# code paths.
ifeq (yes,$(have-loop-to-function))
CFLAGS-dl-tunables.c += -fno-tree-loop-distribute-patterns
endif

all-dl-routines = $(dl-routines) $(sysdep-dl-routines)
# But they are absent from the shared libc, because that code is in ld.so.
elide-routines.os = \
  $(all-dl-routines) \
  dl-early_allocate \
  dl-exception \
  dl-origin \
  dl-reloc-static-pie \
  dl-support \
  dl-sysdep \
  enbl-secure \
  rtld_static_init \
  thread_gscope_wait \
  # elide-routines.os

# These object files are only included in the dynamically-linked libc.
shared-only-routines = \
  libc-dl-profile \
  libc-dl-profstub \
  libc-dl_find_object \
  # shared-only-routines

# ld.so uses those routines, plus some special stuff for being the program
# interpreter and operating independent of libc.
rtld-routines = \
  $(all-dl-routines) \
  dl-audit \
  dl-compat \
  dl-diagnostics \
  dl-diagnostics-cpu \
  dl-diagnostics-kernel \
  dl-environ \
  dl-hwcaps \
  dl-hwcaps-subdirs \
  dl-hwcaps_split \
  dl-libc_freeres \
  dl-minimal \
  dl-mutex \
  dl-profile \
  dl-sysdep \
  dl-usage \
  rtld \
  # rtld-routines

all-rtld-routines = $(rtld-routines) $(sysdep-rtld-routines)

CFLAGS-dl-runtime.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-dl-lookup.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-dl-iteratephdr.c += $(uses-callbacks)

# Called during static library initialization, so turn stack-protection
# off for non-shared builds.
CFLAGS-dl-minimal-malloc.o = $(no-stack-protector)
CFLAGS-dl-minimal-malloc.op = $(no-stack-protector)

# On targets without __builtin_memset, rtld.c uses a hand-coded loop
# in _dl_start.  Make sure this isn't turned into a call to regular memset.
ifeq (yes,$(have-loop-to-function))
CFLAGS-rtld.c += -fno-tree-loop-distribute-patterns
endif

# Compile rtld itself without stack protection.
# Also compile all routines in the static library that are elided from
# the shared libc because they are in libc.a in the same way.

CFLAGS-.o += $(call elide-stack-protector,.o,$(elide-routines.os))
CFLAGS-.op += $(call elide-stack-protector,.op,$(elide-routines.os))
CFLAGS-.os += $(call elide-stack-protector,.os,$(all-rtld-routines))

# Add the requested compiler flags to the early startup code.
CFLAGS-dl-misc.os += $(rtld-early-cflags)
CFLAGS-dl-printf.os += $(rtld-early-cflags)
CFLAGS-dl-setup_hash.os += $(rtld-early-cflags)
CFLAGS-dl-sysdep.os += $(rtld-early-cflags)
CFLAGS-dl-tunables.os += $(rtld-early-cflags)
CFLAGS-dl-write.os += $(rtld-early-cflags)
CFLAGS-dl-writev.os += $(rtld-early-cflags)
CFLAGS-rtld.os += $(rtld-early-cflags)

ifeq ($(unwind-find-fde),yes)
routines += unwind-dw2-fde-glibc
shared-only-routines += unwind-dw2-fde-glibc
endif

before-compile  += $(objpfx)trusted-dirs.h
generated	+= trusted-dirs.h trusted-dirs.st for-renamed/renamed.so
generated-dirs	+= for-renamed

ifeq ($(build-shared),yes)
ld-map		= $(common-objpfx)ld.map
endif

ifeq (yes,$(build-shared))
extra-objs = \
  $(all-rtld-routines:%=%.os) \
  interp.os \
  sofini.os \
  # extra-objs
generated += \
  dl-allobjs.os \
  ld.so ldd \
  librtld.os \
  # generated
install-others	= $(inst_rtlddir)/$(rtld-installed-name) $(inst_bindir)/ld.so
install-bin-script = ldd
endif

others		= sprof sln
install-bin	= sprof
others-static   = sln
install-rootsbin = sln
sln-modules	:= static-stubs
extra-objs	+= $(sln-modules:=.o)

ifeq (yes,$(use-ldconfig))
ifeq (yes,$(build-shared))
others-static	+= ldconfig
others		+= ldconfig
install-rootsbin += ldconfig

ldconfig-modules := \
  cache \
  chroot_canon \
  readlib \
  static-stubs \
  stringtable \
  xmalloc \
  xstrdup \
  # ldconfig-modules
extra-objs	+= $(ldconfig-modules:=.o)
others-extras   = $(ldconfig-modules)
endif
endif

# To find xmalloc.c and xstrdup.c
vpath %.c ../locale/programs

ifeq ($(build-shared),yes)
extra-objs += sotruss-lib.os sotruss-lib.so
install-others += $(inst_auditdir)/sotruss-lib.so
install-bin-script += sotruss
generated += sotruss
libof-sotruss-lib = extramodules
LDFLAGS-sotruss-lib.so += $(z-now-$(bind-now))
$(objpfx)sotruss-lib.so: $(objpfx)sotruss-lib.os
	$(build-module-asneeded)
$(objpfx)sotruss-lib.so: $(common-objpfx)libc.so $(objpfx)ld.so \
	$(common-objpfx)libc_nonshared.a

$(objpfx)sotruss: sotruss.sh $(common-objpfx)config.make
	sed -e 's%@VERSION@%$(version)%g' \
	    -e 's%@TEXTDOMAINDIR@%$(localedir)%g' \
	    -e 's%@PREFIX@%$(prefix)%g' \
	    -e 's|@PKGVERSION@|$(PKGVERSION)|g' \
	    -e 's|@REPORT_BUGS_TO@|$(REPORT_BUGS_TO)|g' \
	    < $< > $@.new
	chmod 555 $@.new
	mv -f $@.new $@
$(inst_auditdir)/sotruss-lib.so: $(objpfx)sotruss-lib.so $(+force)
	$(do-install-program)
endif

tests-static-normal := \
  tst-array1-static \
  tst-array5-static \
  tst-dl-iter-static \
  tst-dlopen-sgid \
  tst-dst-static \
  tst-env-setuid-static \
  tst-getauxval-static \
  tst-linkall-static \
  tst-single_threaded-pthread-static \
  tst-single_threaded-static \
  tst-tls-allocation-failure-static \
  tst-tlsalign-extern-static \
  tst-tlsalign-static \
  # tests-static-normal

tests-static-internal := \
  tst-dl-printf-static \
  tst-dl_find_object-static \
  tst-env-setuid-tunables \
  tst-ptrguard1-static \
  tst-stackguard1-static \
  tst-tls1-static \
  tst-tls1-static-non-pie \
  tst-tunables \
  tst-tunables-enable_secure \
  # tests-static-internal

CRT-tst-tls1-static-non-pie := $(csu-objpfx)crt1.o
tst-tls1-static-non-pie-no-pie = yes

tests-container := \
  tst-ldconfig-bad-aux-cache \
  tst-ldconfig-ld_so_conf-update \
  # tests-container

ifeq (no,$(build-hardcoded-path-in-tests))
# This is an ld.so.cache test, and RPATH/RUNPATH in the executable
# interferes with its test objectives.
tests-container += tst-glibc-hwcaps-prepend-cache
endif

tests := \
  tst-array1 \
  tst-array2 \
  tst-array3 \
  tst-array4 \
  tst-array5 \
  tst-auxv \
  tst-decorate-maps \
  tst-dl-hash \
  tst-env-setuid \
  tst-leaks1 \
  tst-stringtable \
  tst-tls9 \
  tst-tunables-enable_secure-env \
  # tests

tests-internal := \
  $(tests-static-internal) \
  tst-tls1 \
  tst-tls_tp_offset \
  # tests-internal

tests-static := $(tests-static-normal) $(tests-static-internal)

ifeq (yes,$(build-shared))
tests-static += \
  tst-single_threaded-static-dlopen \
  tst-tls9-static \
  # tests-static

static-dlopen-environment = \
  LD_LIBRARY_PATH=$(ld-library-path):$(common-objpfx)dlfcn
tst-tls9-static-ENV = $(static-dlopen-environment)
tst-single_threaded-static-dlopen-ENV = $(static-dlopen-environment)
tst-rootdir-ENV = LD_LIBRARY_PATH=/

tests += \
  argv0test \
  constload1 \
  dblload \
  dblunload \
  filter \
  global \
  initfirst \
  lateglobal \
  loadfail \
  multiload \
  next \
  nodelete \
  nodelete2 \
  nodlopen \
  nodlopen2 \
  noload \
  order \
  order2 \
  origtest \
  preloadtest \
  reldep \
  reldep2 \
  reldep3 \
  reldep4 \
  reldep5 \
  reldep6 \
  reldep7 \
  reldep8 \
  resolvfail \
  restest1 \
  restest2 \
  tst-absolute-sym \
  tst-absolute-zero \
  tst-addr1 \
  tst-align \
  tst-align2 \
  tst-align3 \
  tst-audit-tlsdesc \
  tst-audit-tlsdesc-dlopen \
  tst-audit-tlsdesc-dlopen2 \
  tst-audit1 \
  tst-audit2 \
  tst-audit8 \
  tst-audit9 \
  tst-audit11 \
  tst-audit12 \
  tst-audit13 \
  tst-audit17 \
  tst-audit18 \
  tst-audit19b \
  tst-audit20 \
  tst-audit21 \
  tst-audit22 \
  tst-audit23 \
  tst-audit24a \
  tst-audit24b \
  tst-audit24c \
  tst-audit24d \
  tst-audit25a \
  tst-audit25b \
  tst-audit28 \
  tst-auditmany \
  tst-auxobj \
  tst-auxobj-dlopen \
  tst-big-note \
  tst-debug1 \
  tst-deep1 \
  tst-dl-is_dso \
  tst-dlclose-lazy \
  tst-dlmodcount \
  tst-dlmopen-dlerror \
  tst-dlmopen-gethostbyname \
  tst-dlmopen-twice \
  tst-dlmopen1 \
  tst-dlmopen3 \
  tst-dlmopen4 \
  tst-dlmopen4-nonpic \
  tst-dlmopen4-pic \
  tst-dlopen-auditdup \
  tst-dlopen-constructor-null \
  tst-dlopen-self \
  tst-dlopen-tlsmodid \
  tst-dlopen-tlsreinit1 \
  tst-dlopen-tlsreinit2 \
  tst-dlopen-tlsreinit3 \
  tst-dlopen-tlsreinit4 \
  tst-dlopenfail \
  tst-dlopenfail-2 \
  tst-dlopenrpath \
  tst-dlsym-error \
  tst-filterobj \
  tst-filterobj-dlopen \
  tst-glibc-hwcaps \
  tst-glibc-hwcaps-mask \
  tst-glibc-hwcaps-prepend \
  tst-global1 \
  tst-global2 \
  tst-gnu2-tls2 \
  tst-hash-collision1 \
  tst-hash-collision1-gnu \
  tst-hash-collision1-sysv \
  tst-hash-collision2 \
  tst-hash-collision2-gnu \
  tst-hash-collision2-sysv \
  tst-initfinilazyfail \
  tst-initorder \
  tst-initorder2 \
  tst-latepthread \
  tst-main1 \
  tst-next-ver \
  tst-nodelete-dlclose \
  tst-nodelete-opened \
  tst-nodelete2 \
  tst-nodeps1 \
  tst-nodeps2 \
  tst-noload \
  tst-non-directory-path \
  tst-null-argv \
  tst-origin \
  tst-p_align1 \
  tst-p_align2 \
  tst-p_align3 \
  tst-recursive-tls \
  tst-relsort1 \
  tst-ro-dynamic \
  tst-rtld-no-malloc \
  tst-rtld-no-malloc-audit \
  tst-rtld-no-malloc-preload \
  tst-rtld-run-static \
  tst-single_threaded \
  tst-single_threaded-pthread \
  tst-sonamemove-dlopen \
  tst-sonamemove-link \
  tst-startup-errno \
  tst-thrlock \
  tst-tls-dlinfo \
  tst-tls-ie \
  tst-tls-ie-dlmopen \
  tst-tls-manydynamic \
  tst-tls4 \
  tst-tls5 \
  tst-tls10 \
  tst-tls11 \
  tst-tls12 \
  tst-tls13 \
  tst-tls14 \
  tst-tls15 \
  tst-tls16 \
  tst-tls17 \
  tst-tls18 \
  tst-tls19 \
  tst-tls20 \
  tst-tls21 \
  tst-tls22 \
  tst-tls22-gnu2 \
  tst-tls23 \
  tst-tlsalign \
  tst-tlsalign-extern \
  tst-tlsgap \
  tst-unique1 \
  tst-unique2 \
  tst-unwind-ctor \
  tst-unwind-main \
  tst-version-hash-zero \
  unload3 \
  unload4 \
  unload5 \
  unload6 \
  unload7 \
  unload8 \
  valgrind-test \
  # tests
tests-cxx = \
  tst-nodelete \
  tst-unique3 \
  tst-unique4 \
  # tests-cxx
ifeq ($(have-test-stb-gnu-unique), yes)
tests-cxx += \
  tst-dlopen-nodelete-reloc \

=== hurd/Makefile ===
# Copyright (C) 1991-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

subdir := hurd

include ../Makeconfig

tests := test-sig-xstate \
	test-sig-rpc-interrupted
$(objpfx)test-sig-xstate: $(shared-thread-library)
$(objpfx)test-sig-rpc-interrupted: $(shared-thread-library) $(objdir)/hurd/libhurduser.so

headers = \
  $(interface-headers) \
  hurd.h \
  hurd/fd.h \
  hurd/id.h \
  hurd/ioctl.h \
  hurd/lookup.h \
  hurd/port.h \
  hurd/resource.h \
  hurd/signal.h \
  hurd/sigpreempt.h \
  hurd/userlink.h \
  # headers

inline-headers = \
  hurd.h \
  hurd/fd.h \
  hurd/port.h \
  hurd/signal.h \
  hurd/userlink.h \
  # inline-headers

# The RPC interfaces go in a separate library.
interface-library := libhurduser
user-interfaces := \
  hurd/auth \
  hurd/crash \
  hurd/exec \
  hurd/exec_startup \
  hurd/fs \
  hurd/fsys \
  hurd/ifsock \
  hurd/interrupt \
  hurd/io \
  hurd/io_reply \
  hurd/io_request \
  hurd/login \
  hurd/msg \
  hurd/msg_reply \
  hurd/msg_request \
  hurd/password \
  hurd/pci \
  hurd/pfinet \
  hurd/process \
  hurd/process_request \
  hurd/socket \
  hurd/startup \
  hurd/term \
  hurd/tioctl \
  # user-interfaces

server-interfaces := \
  faultexc \
  hurd/msg \
  # server-interfaces

routines = \
  $(dtable) \
  $(inlines) \
  $(sig) \
  errno-loc \
  fchroot \
  fd-cleanup \
  fopenport \
  get-host \
  geteuids \
  getumask \
  hurdauth \
  hurdchdir \
  hurdexec \
  hurdfchdir \
  hurdid \
  hurdinit \
  hurdlock \
  hurdlookup \
  hurdmsg \
  hurdpid \
  hurdports \
  hurdprio \
  hurdrlimit \
  hurdselect \
  hurdsock \
  hurdstartup \
  lookup-at \
  lookup-retry \
  msgportdemux \
  path-lookup \
  pid2task \
  port-cleanup \
  ports-get \
  ports-set \
  privports \
  report-wait \
  set-host \
  setauth \
  seteuids \
  task2pid \
  vpprintf \
  xattr \
  # routines
sig = \
  catch-exc \
  catch-signal \
  exc2signal \
  hurd-raise \
  hurdfault \
  hurdkill \
  hurdsig \
  intr-msg \
  longjmp-ts \
  preempt-sig \
  siginfo \
  sigthreadmask \
  sigunwind \
  thread-cancel \
  thread-self \
  trampoline \
  # sig
dtable = \
  alloc-fd \
  ctty-input \
  ctty-output \
  dtable \
  fd-close \
  fd-read \
  fd-write \
  getdport \
  hurdioctl \
  intern-fd \
  new-fd \
  openport \
  port2fd \
  # dtable
inlines = $(inline-headers:%.h=%-inlines)

# XXX this is a temporary hack; see hurdmalloc.h
routines += hurdmalloc

# Binary compatibility for libc.so.0.2[GLIBC_2.0].
ifeq ($(build-shared),yes)
routines += compat-20
endif

shared-only-routines = compat-20

# For each of the $(inline-headers), generate a trivial source
# file that will #include it to define its inline functions as real functions.
$(inlines:%=$(objpfx)%.c): $(objpfx)%-inlines.c: %.h
	(h="`echo $(subst /,_,$*) | tr '[a-z]' '[A-Z]'`"; \
	 echo "#define _$${h}_H_EXTERN_INLINE /* Define real function.  */"; \
	 echo "#define _$${h}_H_HIDDEN_DEF    /* Declare hidden definition.  */"; \
	 echo '#include "$<"') > $@-new
	mv -f $@-new $@
generated += $(inlines:=.c)

# Avoid ssp before TLS is initialized.
CFLAGS-hurdstartup.o = $(no-stack-protector)
CFLAGS-RPC_exec_startup_get_info.o = $(no-stack-protector)

# Make it simpler to unwind over INTR_MSG_TRAP
CFLAGS-intr-msg.o = -fno-omit-frame-pointer
CFLAGS-intr-msg.os = -fno-omit-frame-pointer

# Make generated headers compatible with all support standards
migheaderpipe := | sed -e 's/\<ino64_t\>/__ino64_t/' -e 's/\<loff_t\>/__loff_t/'
include ../mach/Machrules
libhurduser-routines += RPC_gsync_wait_intr
include ../Rules

# intr-rpc.defs defines the INTR_INTERFACE macro to make the generated RPC
# stubs import <hurd/signal.h> and #define __mach_msg to
# _hurd_intr_rpc_mach_msg.
user-MIGFLAGS += -imacros intr-rpc.defs

# The special exc server for sigthread faults uses a special prefix.
MIGFLAGS-faultexc = -prefix _hurdsig_fault_

# We need this static dependency to get faultexc.h generated the first time.
$(objpfx)hurdfault.o $(objpfx)hurdfault.d: \
	$(objpfx)faultexc_server.h $(objpfx)faultexc_server.c

=== string/Makefile ===
# Copyright (C) 1991-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for string portion of library.
#
subdir	:= string

include ../Makeconfig

headers := \
  argz.h \
  bits/byteswap.h \
  bits/endian.h \
  bits/endianness.h \
  bits/string_fortified.h \
  bits/strings_fortified.h \
  bits/uintn-identity.h \
  byteswap.h \
  endian.h \
  envz.h \
  memory.h \
  string.h \
  strings.h \
# headers

routines := \
  _strerror \
  argz-addsep \
  argz-append \
  argz-count \
  argz-create \
  argz-ctsep \
  argz-delete \
  argz-extract \
  argz-insert \
  argz-next \
  argz-replace \
  argz-stringify \
  basename \
  bcopy \
  bzero \
  envz \
  explicit_bzero \
  ffs \
  ffsll \
  memccpy \
  memchr \
  memcmp \
  memcmpeq \
  memcpy \
  memfrob \
  memmem \
  memmove \
  mempcpy \
  memrchr \
  memset \
  rawmemchr \
  sigabbrev_np \
  sigdescr_np \
  stpcpy \
  stpncpy \
  strcasecmp \
  strcasecmp_l \
  strcasestr \
  strcat \
  strchr \
  strchrnul \
  strcmp \
  strcoll \
  strcoll_l \
  strcpy \
  strcspn \
  strdup \
  strerror \
  strerror_l \
  strerrordesc_np \
  strerrorname_np \
  strfry \
  string-inlines \
  strlcat \
  strlcpy \
  strlen \
  strncase \
  strncase_l \
  strncat \
  strncmp \
  strncpy \
  strndup \
  strnlen \
  strpbrk \
  strrchr \
  strsep \
  strsignal \
  strspn \
  strstr \
  strtok \
  strtok_r \
  strverscmp \
  strxfrm \
  strxfrm_l \
  swab \
  wordcopy \
  xpg-strerror \
# routines

# Exclude fortified routines from being built with _FORTIFY_SOURCE
routines_no_fortify += \
  explicit_bzero \
  memcpy \
  memmove \
  mempcpy \
  memset \
  stpcpy \
  stpncpy \
  strcat \
  strcpy \
  strlcat \
  strlcpy \
  strncat \
  strncpy \
  # routines_no_fortify

tests := \
  bug-envz1 \
  bug-strcoll1 \
  bug-strcoll2 \
  bug-strncat1 \
  bug-strpbrk1 \
  bug-strspn1 \
  bug-strtok1 \
  inl-tester \
  noinl-tester \
  stratcliff \
  test-bcopy \
  test-bzero \
  test-endian-file-scope \
  test-endian-sign-conversion \
  test-endian-types \
  test-explicit_bzero \
  test-ffs \
  test-memccpy \
  test-memchr \
  test-memcmp \
  test-memcmpeq \
  test-memcpy \
  test-memcpy-large \
  test-memmem \
  test-memmove \
  test-mempcpy \
  test-memrchr \
  test-memset \
  test-rawmemchr \
  test-sig_np \
  test-stpcpy \
  test-stpncpy \
  test-strcasecmp \
  test-strcasestr \
  test-strcat \
  test-strchr \
  test-strchrnul \
  test-strcmp \
  test-strcpy \
  test-strcspn \
  test-strdup \
  test-strlen \
  test-strncasecmp \
  test-strncat \
  test-strncmp \
  test-strncpy \
  test-strndup \
  test-strnlen \
  test-strnlen-nonarray \
  test-strpbrk \
  test-strrchr \
  test-strspn \
  test-strstr \
  testcopy \
  tester \
  tst-bswap \
  tst-cmp \
  tst-endian \
  tst-inlcall \
  tst-memmove-overflow \
  tst-strerror-fail \
  tst-strfry \
  tst-strlcat \
  tst-strlcat2 \
  tst-strlcpy \
  tst-strlcpy2 \
  tst-strlen \
  tst-strtok \
  tst-strtok_r \
  tst-strxfrm \
  tst-strxfrm2 \
  tst-svc \
  tst-svc2 \
  tst-xbzero-opt \
# tests

tests-static-internal := \
  test-memswap \
# tests-static-internal

tests-internal := \
  $(tests-static-internal) \
  # tests-internal

tests-static := \
  $(tests-static-internal) \
  # tests-static

# Both tests require the .mo translation files generated by msgfmt.
tests-translation := \
  tst-strerror \
  tst-strsignal \
# tests-translation

tests-container   += $(tests-translation)
ifeq ($(MSGFMT),:)
tests-unsupported += $(tests-translation)
endif

# This test allocates a lot of memory and can run for a long time.
xtests += tst-strcoll-overflow

# This test runs for a long time.
xtests += test-strncmp-nonarray

# This test needs libdl.
ifeq (yes,$(build-shared))
tests += test-strerror-errno
endif

ifeq ($(run-built-tests),yes)
tests-special += $(objpfx)tst-svc-cmp.out
endif

include ../Rules

CFLAGS-tester.c += $(test-config-cflags-wno-fortify-source)
CFLAGS-inl-tester.c += -fno-builtin \
		       $(test-config-cflags-wno-fortify-source)
CFLAGS-noinl-tester.c += -fno-builtin \
		       $(test-config-cflags-wno-fortify-source)
CFLAGS-tst-strlen.c += -fno-builtin
CFLAGS-stratcliff.c += -fno-builtin
CFLAGS-test-ffs.c += -fno-builtin
CFLAGS-tst-inlcall.c += -fno-builtin
CFLAGS-tst-xbzero-opt.c += -O3
CFLAGS-test-endian-sign-conversion.c += -Werror -Wsign-conversion
# BZ 21006: Resolve all functions but at least explicit_bzero at startup.
# Otherwise the test fails on s390x as the memcpy in prepare_test_buffer is
# done by loading r4 / r5 with the test_pattern and using store multiple
# instruction to store r4 / r5 to buf.  If explicit_bzero would be resolved in
# setup_explicit_clear, r4 / r5 would be stored to stack by _dl_runtime_resolve
# and the call to memmem in count_test_patterns will find a hit of the
# test_pattern on the stack.
LDFLAGS-tst-xbzero-opt = -z now

# Called during TLS initialization.
CFLAGS-memcpy.c += $(no-stack-protector)
CFLAGS-wordcopy.c += $(no-stack-protector)
# Called during static initialization
CFLAGS-strncmp.c += $(no-stack-protector)
CFLAGS-memset.c += $(no-stack-protector)

CFLAGS-argz-next.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-basename.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-ffs.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-memmem.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-memchr.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-mempcpy.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-stpcpy.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-strnlen.c += $(config-cflags-wno-ignored-attributes)

ifeq ($(run-built-tests),yes)
$(objpfx)tst-svc-cmp.out: tst-svc.expect $(objpfx)tst-svc.out
	cmp $^ > $@; \
	$(evaluate-test)

LOCALES := de_DE.UTF-8 en_US.ISO-8859-1 en_US.UTF-8 \
           tr_TR.ISO-8859-9 tr_TR.UTF-8 cs_CZ.UTF-8 \
	   da_DK.ISO-8859-1 en_GB.UTF-8 pt_BR.UTF-8
include ../gen-locales.mk

$(objpfx)test-strcasecmp.out: $(gen-locales)
$(objpfx)test-strncasecmp.out: $(gen-locales)
$(objpfx)tst-strxfrm.out: $(gen-locales)
$(objpfx)tst-strxfrm2.out: $(gen-locales)
# bug-strcoll2 needs cs_CZ.UTF-8 and da_DK.ISO-8859-1.
$(objpfx)bug-strcoll2.out: $(gen-locales)
$(objpfx)tst-strcoll-overflow.out: $(gen-locales)
$(objpfx)tst-strsignal.out: $(gen-locales)
$(objpfx)tst-strerror.out: $(gen-locales)

endif

=== sysvipc/Makefile ===
# Copyright (C) 1995-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for sysvipc portion of the library.
#
subdir	:= sysvipc

include ../Makeconfig

headers	:= sys/ipc.h sys/msg.h sys/sem.h sys/shm.h \
	   bits/ipctypes.h bits/ipc.h bits/msq.h bits/sem.h bits/shm.h

routines := ftok \
	    msgsnd msgrcv msgget msgctl \
	    semop semget semctl semtimedop \
	    shmat shmdt shmget shmctl

tests    := test-sysvmsg test-sysvsem test-sysvshm

tests-time64 := test-sysvmsg-time64 test-sysvsem-time64 test-sysvshm-time64

include ../Rules

CFLAGS-msgrcv.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-msgsnd.c += -fexceptions -fasynchronous-unwind-tables

$(objpfx)test-sysvsem: $(librt)
$(objpfx)test-sysvsem-time64: $(librt)

=== wctype/Makefile ===
# Copyright (C) 1996-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for wctype portion of the library.
#
subdir	:= wctype

include ../Makeconfig

headers		:= wctype.h bits/wctype-wchar.h
routines	:= wcfuncs wctype iswctype wctrans towctrans \
		   wcfuncs_l wctype_l iswctype_l wctrans_l towctrans_l

tests	:= test_wctype test_wcfuncs bug-wctypeh

include ../Rules

CFLAGS-wcfuncs.c += $(config-cflags-wno-ignored-attributes)

=== htl/tests/Makefile ===
ifdef INSTALL_ROOT
INSTALL_ROOT_CPPFLAGS = -isystem $(INSTALL_ROOT)/include
INSTALL_ROOT_LDFLAGS = -L$(INSTALL_ROOT)/lib -Wl,-rpath,$(INSTALL_ROOT)/lib
endif

CFLAGS=-Wall -g

LDLIBS = -lpthread

CHECK_SRC := \
  test-1.c \
  test-10.c \
  test-11.c \
  test-12.c \
  test-13.c \
  test-14.c \
  test-15.c \
  test-16.c \
  test-17.c \
  test-2.c \
  test-3.c \
  test-6.c \
  test-7.c \
  test-8.c \
  test-9.c \
  test-__pthread_destroy_specific-skip.c \
  # CHECK_SRC

CHECK_OBJS := $(addsuffix .o,$(basename $(notdir $(CHECK_SRC))))
CHECK_PROGS := $(basename $(notdir $(CHECK_SRC))) \
	$(addsuffix -static, $(basename $(CHECK_SRC)))

%.o: %.c
	$(CC) $(INSTALL_ROOT_CPPFLAGS) $(CPPFLAGS) $(CFLAGS) $< -c -o $@

%: %.o
	$(CC) $(INSTALL_ROOT_LDFLAGS) $(LDFLAGS) $< -o $@ $(LDLIBS)

%-static: %.o
	$(CC) -static $(INSTALL_ROOT_LDFLAGS) $(LDFLAGS) $< -o $@ $(LDLIBS)

check: $(CHECK_OBJS) $(CHECK_PROGS)
	for i in $(CHECK_PROGS); do		\
	  echo -n Running $$i...\ ;		\
	  if ./$$i 2>&1 > $$i.out;		\
	  then					\
	    echo Success.;			\
	  else					\
	    echo Failure.;			\
	  fi					\
	done

clean:
	rm -f $(CHECK_OBJS) $(CHECK_PROGS) \
	  $(addsuffix .out,$(basename $(notdir $(CHECK_PROGS))))

=== sysdeps/generic/Makefile ===
# Copyright (C) 1992-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

ifeq ($(subdir),string)
sysdep_routines += tls-internal
CFLAGS-wordcopy.c += -Wno-uninitialized
endif

ifeq ($(subdir),elf)
ifeq ($(enable-gsframe),yes)
sysdep_routines += sframe-read sframe
endif
ifeq (yes:yes,$(build-shared):$(unwind-find-fde))
# This is needed to support g++ v2 and v3.
sysdep_routines += framestate unwind-pe
shared-only-routines += framestate unwind-pe
endif
endif

ifeq ($(subdir),malloc)
sysdep_malloc_debug_routines += malloc-hugepages
endif

ifeq ($(subdir),misc)
sysdep_routines += malloc-hugepages
endif

=== debian/changelog ===
glibc (2.42-2ubuntu2) resolute; urgency=medium

  *  Fix gconv regression on i386 due to modules being multi-arch foreign
     while containing arch-specific solibs.

 -- Simon Poirier <simon.poirier@canonical.com>  Tue, 28 Oct 2025 18:33:33 -0400

glibc (2.42-2ubuntu1) resolute; urgency=medium

  [ Simon Chopin ]
  * Disable ELF metadata because it creeps into everything (LP: #2109333)

  [ Simon Poirier ]
  * Merge Debian glibc 2.42 branch. Dropped changes, superseded:
    - Fix pthread page guard on linux<6.13
    - Revert dropping the ldconfig wrapper, as we still have a lot of packages
      that don't ship a trigger but instead call in postinst. (LP: #2127856)
    - Explicitly enable sframe
  * d/p/git-updates.diff: Update from upstream stable branch.

 -- Simon Poirier <simon.poirier@canonical.com>  Mon, 20 Oct 2025 12:03:47 +0200

glibc (2.42-2) experimental; urgency=medium

  [ Samuel Thibault ]
  * patches/hurd-i386/git-random-malloc.diff: Use upstream patch.

  [ Michael Biebl ]
  * debian/rules.d/build.mk: remove /lib from ld.so.conf files.  Closes:
    #1111805.

  [ Luca Monducci ]
  * Update Italian debconf translation.  Closes: #1111902.

  [ Aurelien Jarno ]
  * debian/control.in/libc, debian/rules.d/debhelper.mk: change
    libc-gconv-modules-extra Recommends into a Depends as many packages still
    use the extra gconv modules.
  * debian/patches/git-updates.diff: update from upstream stable branch.
    - debian/patches/hurd-i386/git-random-malloc.diff: upstreamed.
    - debian/symbols.wildcards: add new GLIBC_ABI_DT_X86_64_PLT,
      GLIBC_ABI_GNU_TLS and GLIBC_ABI_GNU2_TLS versions.
  * debian/sysdeps/riscv64.mk: remove TIMEOUTFACTOR override as buildds are
    not QEMU based anymore.
  * debian/sysdeps/riscv64.mk: configure with --enable-multi-arch.
  * debian/control.in/main: drop ${shlibs:Depends} for
    libc-gconv-modules-extra to avoid creating a dependency loop. This can be
    re-added once libc6 changes back the Depends into a Recommends.

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 02 Sep 2025 23:05:31 +0200

glibc (2.42-1) experimental; urgency=medium

  [ Aurelien Jarno ]
  * New upstream release:
    - debian/copyright: update following upstream changes.
    - debian/symbols.wildcards: add 2.42.
    - debian/control.in/main: bump binutils-for-host Build-Depends to >= 2.39.
    - debian/patches/git-updates.diff: update from upstream stable branch.
    - debian/patches/hurd-i386/git-proc_reauth.diff: upstreamed.
    - debian/patches/hurd-i386/git-mig-strncpy.diff: upstreamed.
    - debian/patches/hurd-i386/git-pthread_sigmask_nothread.diff: upstreamed.
    - debian/patches/hurd-i386/git-rt-timedwait-realtime.diff: upstreamed.
    - debian/patches/hurd-i386/git-pthread_setcancel.diff: upstreamed.
    - debian/patches/hurd-i386/git-dup-refcnt.diff: upstreamed.
    - debian/patches/hurd-i386/git-xstate.diff: upstreamed.
    - debian/patches/hurd-i386/git-utime-EINVAL.diff: upstreamed.
    - debian/patches/hurd-i386/git-xstate-initialized.diff: upstreamed.
    - debian/patches/hurd-i386/git-signal-fpe-exceptions.diff: upstreamed.
    - debian/patches/hurd-i386/git-symlink-eexist.diff: upstreamed.
    - debian/patches/hurd-i386/git-rename.diff: upstreamed.
    - debian/patches/hurd-i386/local-pthread_once.diff-2.42: renamed and
      replace debian/patches/hurd-i386/local-pthread_once.diff.
    - debian/patches/hurd-i386/hurd-i386/local-no_unsupported_ioctls.diff:
      rebased.
    - debian/patches/hurd-i386/local-static_pthread_setcancelstate.diff:
      dropped, obsolete.
    - debian/patches/any/local-tcsetaddr.diff: rebased.
  * debian/debhelper.in/libc.preinst: drop support code for upgrading from
    glibc < 2.34.
  * debian/debhelper.in/libc.preinst: remove kFreeBSD support code.
  * debian/debhelper.in/libc.postinst: remove support code to upgrade to
    trixie.
  *  Drop support for /etc/locales.alias (Closes: #1095101):
    - debian/debhelper.in/locales.install: stop installing /etc/locales.alias
    - debian/debhelper.in/locales.links: remove
    - debian/local/usr_sbin/locale-gen: stop passing locales.alias in the
      localedef call.
    - debian/patches/all/local-alias-et_EE.diff: drop, obsolete.
    - debian/patches/all/local-ru_RU.diff: drop, obsolete
  * debian/rules.d/{build.mk,debhelper.mk}: add makefile dependencies to get
    the package buildable with make --shuffle=reverse.  Closes: #1105334.
  * debian/rules, debian/rules.d/control.mk: remove temporary libc{6,6.1,0.3}
    files after the debian/control rule instead of in the clean rule.
  * debian/rules: drop now useless removal of files from the clean rule.
  * debian/rules: simplyfing using dpkg mk fragments files.
  * debian/rules.d/debhelper.mk: merge normal and stage1 debhelper_% targets.
  * Split-out gconv modules for non-Latin-1 and non-UTF encoding into a
    separate package (Closes: #1005193):
    - debian/control.in/main: add libc-gconv-modules-extra.
    - debian/control.in/libc: recommends libc-gconv-modules-extra.
    - debian/debhelper.in/libc.install: do not list any gconv file, the list
      of gconv files is now computed dynamically.
    - debian/rules.d/debhelper.mk: dynamically compute the list of gconv files
      based on the gconv configuration files, for both the libc and
      libc-gconv-modules-extra packages.
    - debian/rules: Add libc-gconv-modules-extra to the list of arch:any
      packages to build.
  * debian/control.in/main, debian/sysdeps/{amd64,arm64,i386,x32}.mk: enable
    SFrame support for amd64 and arm64 builds.

  [ Samuel Thibault ]
  * debian/testsuite-xfail-debian.mk: Update xfails.  Closes: #1110125.
  * debian/patches/hurd-i386/git-random-malloc.diff: Fix /hurd/random startup.

  [ Simon Chopin ]
  * debian/rules.d/build.mk: use envvars for CFLAGS rather than configparms
    (LP: #2115734)
  * debian/rules.d/tarball.mk: document the hash when importing from upstream
    branch.



=== debian/control ===
Source: glibc
Section: libs
Priority: required
Build-Depends: gettext, dpkg (>= 1.18.7), dpkg-dev (>= 1.17.14), xz-utils, file, quilt,
 autoconf, gawk, debhelper-compat (= 13), rdfind, symlinks, netbase, gperf, bison,
 linux-libc-dev (>= 3.9) [linux-any], systemtap-sdt-dev [linux-any],
 libaudit-dev [linux-any], libcap-dev [linux-any] <!stage2>, libselinux1-dev [linux-any] <!stage2>,
 mig-for-host (>= 1.8+git20200618-7~) [hurd-any], gnumach-dev (>= 2:1.8+git20200710-2~) [hurd-any],
 hurd-dev (>= 1:0.9.git20201127-4~) [hurd-any] | hurd-headers-dev [hurd-any],
 binutils-for-host (>= 2.39), binutils-for-host (>= 2.45) [amd64 arm64 i386 x32],
 g++-for-host, g++-multilib [amd64 i386 mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el powerpc ppc64 sparc sparc64 x32] <!nobiarch>,
 g++-for-host (>= 14.1.0-4) [arm64],
 python3:native,
 libidn2-0 (>= 2.0.5~) <!nocheck>,
 libc-bin (>= 2.42) <cross>,
 libgd-dev <!stage1 !stage2>,
Build-Depends-Indep: perl, po-debconf (>= 1.0)
Rules-Requires-Root: no
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: GNU Libc Maintainers <debian-glibc@lists.debian.org>
Uploaders: Clint Adams <clint@debian.org>, Aurelien Jarno <aurel32@debian.org>, Samuel Thibault <sthibault@debian.org>
Standards-Version: 4.6.2
Vcs-Browser: https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/glibc
Vcs-Git: https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/glibc
XSBC-Original-Vcs-Browser: https://salsa.debian.org/glibc-team/glibc
XSBC-Original-Vcs-Git: https://salsa.debian.org/glibc-team/glibc.git
Homepage: https://www.gnu.org/software/libc/libc.html

Package: libc-bin
Architecture: any
Section: libs
Priority: required
Essential: yes
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: dh-lua (<< 27+nmu1~)
Suggests: manpages
Build-Profiles: <!stage1>
Description: GNU C Library: Binaries
 This package contains utility programs related to the GNU C Library.
 .
  * getconf: query system configuration variables
  * getent: get entries from administrative databases
  * iconv, iconvconfig: convert between character encodings
  * ldd, ldconfig: print/configure shared library dependencies
  * locale, localedef: show/generate locale definitions
  * tzselect, zdump, zic: select/dump/compile time zones

Package: libc-dev-bin
Architecture: any
Section: libdevel
Priority: optional
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: manpages, manpages-dev
Suggests: libc-devtools (>> 2.42)
Build-Profiles: <!stage1>
Description: GNU C Library: Development binaries
 This package contains utility programs related to the GNU C Library
 development package.
 .
  * gencat: generate message catalogs

Package: libc-devtools
Architecture: any
Section: devel
Priority: optional
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libc-dev-bin (<< 2.31-8)
Replaces: libc-dev-bin (<< 2.31-8)
Recommends: libc-dev (= ${binary:Version}), manpages, manpages-dev
Build-Profiles: <!stage1> <!stage2>
Description: GNU C Library: Development tools
 This package contains development tools shipped by the GNU C
 Library.
 .
  * memusage, memusagestat: profile a program's memory usage
  * mtrace: interpret the malloc trace log
  * sotruss: trace shared library calls
  * sprof: display shared object profiling data

Package: libc-gconv-modules-extra
Architecture: any
Section: libs
Priority: optional
Multi-Arch: same
Depends: ${misc:Depends}
Breaks: libc6 (<< 2.42-1) [!alpha !hurd-any], libc6.1 (<< 2.42-1) [alpha], libc0.3 (<< 2.42-1) [hurd-any]
Replaces: libc6 (<< 2.42-1) [!alpha !hurd-any], libc6.1 (<< 2.42-1) [alpha], libc0.3 (<< 2.42-1) [hurd-any]
Build-Profiles: <!stage1>
Description: GNU C Library: Non-essential gconv modules
 This package provides additional character set conversion modules for the GNU
 C Library's gconv facility, to support encodings other than Latin-1 and UTF
 based.

Package: libc-l10n
Architecture: all
Section: localization
Priority: standard
Multi-Arch: foreign
Depends: ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: localization files
 This package contains the translation files for the GNU C library and
 utility programs.

Package: glibc-doc
Architecture: all
Section: doc
Priority: optional
Multi-Arch: foreign
Depends: ${misc:Depends}, glibc-doc-reference (>= 2.18)
Build-Profiles: <!stage1>
Description: GNU C Library: Documentation
 Contains the complete GNU C Library ChangeLog.  The GNU C Library Reference
 manual has been moved into glibc-doc-reference for licensing reasons.

Package: glibc-source
Architecture: all
Section: devel
Priority: optional
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: xz-utils
Build-Profiles: <!stage1>
Description: GNU C Library: sources
 This package contains the sources and patches which are needed to
 build glibc.

Package: locales
Architecture: all
Section: localization
Priority: standard
Depends: libc-bin (>> 2.42), ${misc:Depends}, debconf | debconf-2.0
Build-Profiles: <!stage1>
Description: GNU C Library: National Language (locale) data [support]
 Machine-readable data files, shared objects and programs used by the
 C library for localization (l10n) and internationalization (i18n) support.
 .
 This package contains tools to generate locale definitions from source
 files (included in this package). It allows you to customize which
 definitions actually get generated. This is a space-saver over how this
 package used to be, with all locales generated by default. This created
 a package that unpacked to an excess of 30 megs.

Package: locales-all
Architecture: any
Section: localization
Priority: optional
Multi-Arch: foreign
Depends: ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: Precompiled locale data
 This package contains the precompiled locale data for all supported locales.
 A better alternative is to install the locales package and only select
 desired locales, but it can be useful on a low-memory machine because some
 locale files take a lot of memory to be compiled.

Package: nscd
Architecture: any
Section: admin
Multi-Arch: foreign
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Conflicts: unscd
Build-Profiles: <!stage1>
Description: GNU C Library: Name Service Cache Daemon
 A daemon which handles passwd, group and host lookups
 for running programs and caches the results for the next
 query. You should install this package only if you use
 slow services like LDAP, NIS or NIS+.

Package: libc6
Architecture: amd64 arc arm64 armel armhf hppa i386 loong64 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32
Section: libs
Priority: optional
Multi-Arch: same
Depends: ${shlibs:Depends}, ${libgcc:Depends}, ${libc-gconv-modules-extra:Depends}
Recommends: libidn2-0 (>= 2.0.5~)
Suggests: glibc-doc, debconf | debconf-2.0, locales [!hurd-any], libnss-nis, libnss-nisplus
Provides: libc6-sparcv9b [sparc sparc64], libc0.3-i686 [hurd-i386], libc6-i686 [i386], libc6-xen [i386], libc6-armel [armel], libc6-armhf [armhf], libc6-lse [arm64]
Conflicts: libc6-i686 [i386], libc6.1-alphaev67 [alpha], libc6-lse [arm64], libc6-xen [i386]
Breaks: nscd (<< 2.42), locales (<< 2.42), locales-all (<< 2.42), gnumach-image-1.8-486 (<< 2:1.8+git20210923~), gnumach-image-1.8-486-dbg (<< 2:1.8+git20210923~), gnumach-image-1.8-xen-486 (<< 2:1.8+git20210923~), gnumach-image-1.8-xen-486-dbg (<< 2:1.8+git20210923~), hurd (<< 1:0.9.git20220301-2), python3-iptables (<< 1.0.0-2), fakechroot (<< 2.19-3.5), tinydns (<< 1:1.05-14), chrony (<< 4.2-3~), valgrind (<< 1:3.19.0-1~), firefox (<< 91~), firefox-esr (<< 91~), systemd (<< 256~rc4-1~), sysvinit-core (<< 3.09-2~), sysvinit (<< 3.09-2~), base-files (<< 13.3~), openssh-server (<< 1:9.9p1-3+hurd.1) [hurd-amd64], dhcpcd (<< 1:10.1.0-7~), pd-scaf (<< 1:0.14.1+darcs20180201-6build4), postgresql-15-pllua (<< 1:2.0.12-4), postgresql-17-pllua (<< 1:2.0.12-4), librccl1 (<< 5.4.3-3build1), libamdhip64-5 (<< 5.7.1-5build1), libhiprtc-builtins5 (<< 5.7.1-5build1), lua-swupdate (<< 2024.12.1+dfsg-1build2), libswupdate0.1 (<< 2024.12.1+dfsg-1build2), uwsgi-plugin-pypy3 (<< 1:0.14.1+darcs20180201-6build4), python3-onnxruntime (<< 1.20.1+dfsg-2~), libde265-0 (<< 1.0.15-1build5) [armel armhf], libmad0 (<< 0.15.1b-11ubuntu2) [armel armhf], libx264-164 (<< 2:0.164.3108+git31e19f9-2build2) [armel armhf], doublecmd-gtk (<< 1.1.22-1build1) [armel armhf], doublecmd-plugins (<< 1.1.22-1build1) [armel armhf], doublecmd-qt (<< 1.1.22-1build1) [armel armhf], libmpeg2-4 (<<  0.5.1-9build2) [armel armhf], libne10-10t64 (<< 1.2.1-5.1build1) [armhf], libpdbg5 (<< 3.5-1+b1) [armel], libopenblas0-openmp (<< 0.3.29+ds-2build1) [armhf s390x], libopenblas0-pthread (<< 0.3.29+ds-2build1) [armhf s390x], libopenblas0-serial (<< 0.3.29+ds-2build1) [armhf s390x], libopenblas64-0-openmp (<< 0.3.29+ds-2build1) [s390x], libopenblas64-0-pthread (<< 0.3.29+ds-2build1) [s390x], libopenblas64-0-serial (<< 0.3.29+ds-2build1) [s390x], libfec0 (<< 1.0-26-gc5d935f-1+b3) [i386], python3-mrgingham (<< 1.25-1), linux-perf (<< 6.12.16-1) [armel], libqt6webenginecore6 (<< 6.8.2+dfsg-3) [i386]
Replaces: libc6-amd64 [amd64],
          libc6-i386 [i386],
          libc0.3-i686 [hurd-i386],
          libc6-i686 [i386],
          libc6-xen [i386],
          libc6-lse [arm64],
          libc6-x32 [x32],
          libc6-powerpc [powerpc],
          libc6-ppc64 [ppc64],
          libc6-s390x [s390x],
          libc6-sparc64 [sparc64],
          libc6-mips64 [mips64 mips64el],
          libc6-mipsn32 [mipsn32 mipsn32el],
          libc6-mips32 [mips mipsel],
          hurd (<< 20120408-3) [hurd-i386]
Build-Profiles: <!stage1>
Description: GNU C Library: Shared libraries
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.

Package: libc6-dev
Architecture: amd64 arc arm64 armel armhf hppa i386 loong64 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32
Section: libdevel
Priority: optional
Multi-Arch: same
Depends: libc6 (= ${binary:Version}) <!stage1>, libc-dev-bin (= ${binary:Version}), ${misc:Depends}, linux-libc-dev [linux-any], gnumach-dev [hurd-any], hurd-dev (>= 20080607-3) [hurd-any] | hurd-headers-dev [hurd-any], ${libcrypt-dev:Depends}, ${rpcsvc-proto:Depends}
Replaces: hurd-dev (<< 20120408-3) [hurd-any], libc6 (<= 2.32-1)
Suggests: glibc-doc, manpages-dev
Provides: libc-dev (= ${binary:Version}), libc6-dev [alpha ia64 hurd-any], libc6-dev-armel [armel], libc6-dev-armhf [armhf]

=== debian/rules ===
#! /usr/bin/make -f
# -*- makefile -*-
# debian/rules file for GNU libc.
# Copyright 1998, 1999 by Joel Klecker <espy@debian.org>
# Copyright 2000-2004 Ben Collins <bcollins@debian.org>
# Copyright 2002-2004 Jeff Bailey <jbailey@debian.org>
# Copyright 2002-2005 Philip Blundell <pb@debian.org>
# Copyright 2002-2006 Daniel Jacobowitz <dan@debian.org>
# Copyright 2002-2006 GOTO Masanori <gotom@debian.org>
# Copyright 2006 Denis Barbier <barbier@debian.org>
# Copyright 2006-2025 Aurelien Jarno <aurel32@debian.org>
# Copyright 2007-2008 Pierre Habouzit <madcoder@debian.org>
# Copyright 2010-2013 Clint Adams <clint@debian.org>
# Copyright 2012-2019 Adam Conrad <adconrad@0c3.net>
# Copyright 2016-2025 Samuel Thibault <sthibault@debian.org>
# This Makefile is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# What are the phases to building glibc?

# Unpack main tarball
# Do any necessary overlays
# Apply patches
# Determine how many builds there are to do.  For Each build:

#  Create build directory
#  Configure
#  Build
#  Test as desired
#  Install to package directories

# Run debian magic to build packages.

# Things you may need to customise:

# These are done as absolute paths so that in the case of filesystem size
# limitations, they can be overridden and spread all over.
build-tree := build-tree
debian-tmp = debian/tmp$(filter-out -libc,-$(curpass))
stamp := $(CURDIR)/stamp-dir/
DUMMY := $(shell mkdir -p $(stamp))

# Beyond here you shouldn't need to customise anything:
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

# The minimum package version with which these packages are compatible.
shlib_dep_ver = $(DEB_VERSION_UPSTREAM)
shlib_dep = $(libc) (>= $(shlib_dep_ver))

DEB_BUILDDIR ?= $(build-tree)/$(DEB_HOST_ARCH)-$(curpass)
DEB_BUILDDIRLIBC ?= $(build-tree)/$(DEB_HOST_ARCH)-libc

GLIBC_SOURCES = $(filter-out debian $(shell basename $(stamp)) $(build-tree), $(wildcard *))

# Support multiple makes at once based on number of processors
include /usr/share/dpkg/buildopts.mk
NJOBS := $(DEB_BUILD_OPTION_PARALLEL:%=-j%)

# use the package settings, not the settings from the environment
define unsetenv
  unexport $(1)
  $(1) =
endef
$(foreach v, CPPFLAGS CFLAGS CXXFLAGS LDFLAGS ELF_PACKAGE_METADATA, $(if $(filter environment,$(origin $(v))),$(eval $(call unsetenv, $(v)))))

# export debhelper substitution variables
export $(build-tree)

# Default setup
GLIBC_PASSES ?= libc

prefix=/usr
bindir=$(prefix)/bin
datadir=$(prefix)/share
complocaledir=$(prefix)/lib/locale
sysconfdir=/etc
libexecdir=$(prefix)/lib
rootsbindir=/sbin
includedir=$(prefix)/include
docdir=$(prefix)/share/doc
mandir=$(prefix)/share/man
sbindir=$(prefix)/sbin
vardbdir=/var/lib/misc
rtlddir=/lib
slibdir=/lib/$(DEB_HOST_MULTIARCH)
libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
mvec = no

rtld_so=$(shell awk 'BEGIN {FS="="} /^ld\.so-version/ {print $$2}' $(DEB_BUILDDIR)/soversions.mk)
rtld_target=$(shell readlink $(debian-tmp)$(rtlddir)/$(rtld_so))
libc_so=$(shell awk 'BEGIN {FS="="} /^libc\.so-version/ {print "libc.so"$$2}' $(DEB_BUILDDIR)/soversions.mk)

BASE_CC = gcc
BASE_CXX = g++
BASE_MIG = mig
# If you override DEB_GCC_VERSION, consider adding DEB_CFLAGS_APPEND=-Wno-error.
DEB_GCC_VERSION ?=

RUN_TESTSUITE = yes
TIMEOUTFACTOR = 25

# Set cross and native compiler names, including version.
CC     = $(DEB_HOST_GNU_TYPE)-$(BASE_CC)$(DEB_GCC_VERSION) -D_DISTRO_EVADE_TIME_BITS
CXX    = $(DEB_HOST_GNU_TYPE)-$(BASE_CXX)$(DEB_GCC_VERSION) -D_DISTRO_EVADE_TIME_BITS
MIG    = $(DEB_HOST_GNU_TYPE)-$(BASE_MIG)
BUILD_CC = $(DEB_BUILD_GNU_TYPE)-$(BASE_CC)
BUILD_CXX = $(DEB_BUILD_GNU_TYPE)-$(BASE_CXX)

BUILD_CFLAGS = -O2 -g -fdebug-prefix-map=$(CURDIR)=.
HOST_CFLAGS = -pipe -O2 -g -fdebug-prefix-map=$(CURDIR)=. $(call xx,extra_cflags)

# 32-bit MIPS builders have a 2GB memory space. This is not enough to
# build test-tgmath3.o with GCC, unless tweaking the garbage collector.
ifeq ($(findstring mips,$(DEB_BUILD_ARCH))-$(DEB_BUILD_ARCH_BITS), mips-32)
  CC += --param ggc-min-expand=10
endif

configure_target := $(DEB_HOST_GNU_TYPE)

# Normally we'll just use this for --build.  If the architecture requires
# that build daemons be able to run a particular optimized library, then
# they can set the --build to match --host for that optimized build.
# Among other things this lets tests run.
configure_build := $(DEB_BUILD_GNU_TYPE)

# Which build pass are we on?
curpass = $(filter-out %_,$(subst _,_ ,$@))

ifneq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
  DEB_ARCH_REGULAR_PACKAGES = $(libc)-dev
  DEB_INDEP_REGULAR_PACKAGES =
  DEB_UDEB_PACKAGES =
  ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
    DEB_BUILD_OPTIONS+=nocheck
  endif
else
  DEB_ARCH_REGULAR_PACKAGES = $(libc) $(libc)-dev $(libc)-dbg libc-bin libc-dev-bin libc-gconv-modules-extra
  ifeq ($(filter stage2,$(DEB_BUILD_PROFILES)),)
    DEB_ARCH_REGULAR_PACKAGES += libc-devtools
  endif
  DEB_INDEP_REGULAR_PACKAGES = glibc-doc glibc-source locales
  ifneq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
    DEB_UDEB_PACKAGES =
  else
    DEB_UDEB_PACKAGES = $(libc)-udeb
  endif
  ## Locales can only be pre-generated during native compiles
  ifeq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
    DEB_ARCH_REGULAR_PACKAGES += locales-all
  endif
endif

# Generic kernel version check
define kernel_check
(if [ $(CURRENT_KERNEL_VERSION) -lt $(1) ]; then \
  false; \
fi)
endef

# Include libidn for both NPTL and FBTL targets.
standard-add-ons = libidn,

# Pull in all the per-arch magic!

-include debian/sysdeps/$(DEB_HOST_ARCH_OS).mk
-include debian/sysdeps/$(DEB_HOST_ARCH).mk

ifneq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
DEB_ARCH_REGULAR_PACKAGES += $(foreach p,$(DEB_ARCH_MULTILIB_PACKAGES), $(if $(findstring -dev,$(p)), $(p)))
else
DEB_ARCH_REGULAR_PACKAGES += $(DEB_ARCH_MULTILIB_PACKAGES)
endif

# Don't run dh_strip on this package
NOSTRIP_$(libc)-dbg = 1

# Put the debug files from these packages in $(libc)-dbg
DEBUG_$(libc) = 1

ifeq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
  ifeq ($(threads),yes)
  DEB_ARCH_REGULAR_PACKAGES += nscd
  endif
endif

# And now the rules...
include debian/rules.d/*.mk

clean:: unpatch
	rm -rf $(patsubst %,debian/tmp-%,$(GLIBC_PASSES))
	rm -rf $(build-tree)
	rm -rf $(stamp)
	rm -rf debian/include

# Required Debian targets
build-arch: $(stamp)info \
	$(patsubst %,$(stamp)build_%,$(GLIBC_PASSES)) \
	$(patsubst %,$(stamp)check_%,$(GLIBC_PASSES)) \
	build-arch-post-check

ifeq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
build-arch: $(stamp)build_locales-all
endif

build-indep: $(stamp)source $(stamp)build_libc

build: build-arch build-indep


binary-indep: build-indep testroot debian/control $(build-tree) \
	$(patsubst %,$(stamp)binaryinst_%,$(DEB_INDEP_REGULAR_PACKAGES))

binary-arch: build-arch testroot debian/control $(build-tree) \
	$(patsubst %,$(stamp)binaryinst_%,$(DEB_ARCH_REGULAR_PACKAGES)) \
	$(patsubst %,$(stamp)binaryinst_%,$(DEB_UDEB_PACKAGES))

binary: binary-indep binary-arch

testroot:
	dh_testroot

=== debian/tests/control ===
Tests: upstream-testsuite
Depends: @builddeps@, binutils, linux-libc-dev [linux-any], gcc
Restrictions: allow-stderr, needs-sudo

=== debian/watch ===
version=3
opts=pgpmode=auto \
https://ftp.gnu.org/gnu/glibc/glibc-([\d\.]+)\.tar\.xz debian uupdate
